from PyQt6.QtCore import QThread, pyqtSignal
from portainer_api import PortainerService


class LoadStacksWorker(QThread):
    stacks_retrieved = pyqtSignal(list)
    error_occurred = pyqtSignal(str)

    def __init__(self, portainer):
        super().__init__()
        self.portainer = portainer

    def run(self):
        try:
            stacks = self.portainer.stacks.list_stacks()
            self.stacks_retrieved.emit(stacks)
        except Exception as e:
            self.error_occurred.emit(str(e))
